/* _NVRM_COPYRIGHT_BEGIN_
 *
 * Copyright 1999-2001 by NVIDIA Corporation.  All rights reserved.  All
 * information contained herein is proprietary and confidential to NVIDIA
 * Corporation.  Any use, reproduction, or disclosure without the written
 * permission of NVIDIA Corporation is prohibited.
 *
 * _NVRM_COPYRIGHT_END_
 */

#ifndef _NV_VM_H_
#define _NV_VM_H_

int      nv_vm_malloc_pages(nv_alloc_t *);
void     nv_vm_unlock_pages(nv_alloc_t *);
void     nv_vm_free_pages(nv_alloc_t *);

#if defined(NV_DBG_MEM)
void     nv_vm_list_page_count(nv_pte_t *, unsigned long);
#else
#define  nv_vm_list_page_count(page_ptr, num_pages)
#endif

#define nv_vm_unlock_and_free_pages(at_count, at) \
    if (at->page_table) {                         \
        if (at_count == 0)                        \
            nv_vm_unlock_pages(at);               \
        nv_vm_free_pages(at);                     \
    }

#endif
